/*----- PROTECTED REGION ID(Vg.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: Vg.cpp,v 1.10 2016-10-18 16:06:08 claudio Exp $";
//=============================================================================
//
// file :        Vg.cpp
//
// description : C++ source for the Vg and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Vg are implemented in this file.
//
// project :     Vg.
//
// $Author: claudio $
//
// $Revision: 1.10 $
// $Date: 2016-10-18 16:06:08 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/vg/src/Vg.cpp,v $
// $Log: Vg.cpp,v $
// Revision 1.10  2016-10-18 16:06:08  claudio
// tango9
//
// Revision 1.9  2013-06-17 10:30:32  lorenzo
// Added DeviceState attribute
//
// Revision 1.8  2013-06-05 15:41:02  lorenzo
// Tango 8.0.5
//
// Revision 1.7  2012-09-10 08:07:44  mdm
// Unregister name fix
//
// Revision 1.6  2012-07-18 09:59:24  mdm
// New version, before test
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Vg.h>
#include <VgClass.h>

#include "devicestate.h"

/*----- PROTECTED REGION END -----*/


/**
 *	Vg class description:
 *	
 */

//================================================================
//
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//----------------------------------------------------------------
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//  On            |  on
//  Off           |  off
//================================================================

namespace Vg_ns
{
	/*----- PROTECTED REGION ID(Vg::namespace_starting) ENABLED START -----*/

	//	static initializations

	/*----- PROTECTED REGION END -----*/	//	Vg::namespace_starting



//--------------------------------------------------------
/**
 *	Method      : Vg::Vg()
 *	Description : Constructors for a Tango device
 *	              implementing the class Vg
 */
//--------------------------------------------------------
Vg::Vg(Tango::DeviceClass *cl, string &s)
	: TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Vg::constructor_1) ENABLED START -----*/

	init_device();

	/*----- PROTECTED REGION END -----*/	//	Vg::constructor_1
}
//--------------------------------------------------------
Vg::Vg(Tango::DeviceClass *cl, const char *s)
	: TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(Vg::constructor_2) ENABLED START -----*/

	init_device();

	/*----- PROTECTED REGION END -----*/	//	Vg::constructor_2
}
//--------------------------------------------------------
Vg::Vg(Tango::DeviceClass *cl, const char *s, const char *d)
	: TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(Vg::constructor_3) ENABLED START -----*/

	init_device();

	/*----- PROTECTED REGION END -----*/	//	Vg::constructor_3
}


//--------------------------------------------------------
/**
 *	Method      : Vg::delete_device()()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Vg::delete_device()
{
	/*----- PROTECTED REGION ID(Vg::delete_device) ENABLED START -----*/

	if(init_completed)
	{
		try
		{
			unregister_name();
		}
		catch (Tango::DevFailed &ex)
		{
			exception_handler(ex, Tango::FAULT, "Vg::delete_device");
		}
	}

	if(tpg_proxy)
	{
		delete tpg_proxy;
		tpg_proxy = 0;
	}

	/*----- PROTECTED REGION END -----*/	//	Vg::delete_device
	delete[] attr_Pressure_read;
	delete[] attr_DeviceState_read;
	
}


//--------------------------------------------------------
/**
 *	Method      : Vg::init_device()
 *	Description : //	will be called at device initialization.
 */
//--------------------------------------------------------
void Vg::init_device()
{
	DEBUG_STREAM << "Vg::init_device() create device " << device_name << endl;

	/*----- PROTECTED REGION ID(Vg::init_device_before) ENABLED START -----*/

	set_state(Tango::INIT);
	set_status("Device initialization");

	tpg_proxy = 0;

	init_completed = false;
	current_back_off = 1;
	last_exception_t = 0;

	/*----- PROTECTED REGION END -----*/	//	Vg::init_device_before
	
	//	Get the device properties (if any) from database
	get_device_property();
	
	attr_Pressure_read = new Tango::DevDouble[1];
	attr_DeviceState_read = new Tango::DevUChar[1];
	
	/*----- PROTECTED REGION ID(Vg::init_device) ENABLED START -----*/

	if(get_state() != Tango::FAULT)
	{
		try
		{
			tpg_proxy = new Tango::DeviceProxy(tpgDevice);
			tpg_proxy->set_timeout_millis(timeout);

			register_name();

			init_completed = true;
		}
		catch (Tango::DevFailed &ex)
		{
			exception_handler(ex, Tango::FAULT, "Vg::init_device");
		}
	}

	/*----- PROTECTED REGION END -----*/	//	Vg::init_device
}



//--------------------------------------------------------
/**
 *	Method      : Vg::get_device_property()
 *	Description : //	Add your own code to initialize
 */
//--------------------------------------------------------
void Vg::get_device_property()
{
	/*----- PROTECTED REGION ID(Vg::get_device_property_before) ENABLED START -----*/

	//	Initialize property data members

	/*----- PROTECTED REGION END -----*/	//	Vg::get_device_property_before


	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("TpgDevice"));
	dev_prop.push_back(Tango::DbDatum("Channel"));
	dev_prop.push_back(Tango::DbDatum("Timeout"));
	dev_prop.push_back(Tango::DbDatum("MaxBackOff"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on VgClass to get class property
		Tango::DbDatum	def_prop, cl_prop;
		VgClass	*ds_class =
			(static_cast<VgClass *>(get_device_class()));
		int	i = -1;

		//	Try to initialize TpgDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  tpgDevice;
		else {
			//	Try to initialize TpgDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  tpgDevice;
		}
		//	And try to extract TpgDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  tpgDevice;

		//	Try to initialize Channel from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  channel;
		else {
			//	Try to initialize Channel from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  channel;
		}
		//	And try to extract Channel value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  channel;

		//	Try to initialize Timeout from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  timeout;
		else {
			//	Try to initialize Timeout from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  timeout;
		}
		//	And try to extract Timeout value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  timeout;

		//	Try to initialize MaxBackOff from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  maxBackOff;
		else {
			//	Try to initialize MaxBackOff from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  maxBackOff;
		}
		//	And try to extract MaxBackOff value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  maxBackOff;


	}
	/*----- PROTECTED REGION ID(Vg::get_device_property_after) ENABLED START -----*/

	if(dev_prop[0].is_empty())
	{
		set_state(Tango::FAULT);
		set_status("TpgDevice property not defined");
		return;
	}

	if(tpgDevice.empty() || tpgDevice.compare("undefined") == 0)
	{
		set_state(Tango::FAULT);
		set_status("TpgDevice property is empty");
		return;
	}

	if(dev_prop[1].is_empty())
	{
		set_state(Tango::FAULT);
		set_status("Channel property not defined");
		return;
	}

	if(channel == -1)
	{
		set_state(Tango::FAULT);
		set_status("Channel property is empty");
		return;
	}

    if(dev_prop[2].is_empty())
    {
		WARN_STREAM << "Timeout property not defined, default: " << timeout << endl;
    }

    if(timeout < 1 || timeout > 10000)
    {
		set_state(Tango::FAULT);
		set_status("Timeout invalid value, valid range [1,10000]");
		return;
    }

    if(dev_prop[3].is_empty())
    {
		WARN_STREAM << "MaxBackOff property not defined, default: " << maxBackOff << endl;
    }

    if(maxBackOff < 0 || maxBackOff > 600)
    {
		set_state(Tango::FAULT);
		set_status("MaxBackOff invalid value, valid range [0,600]");
		return;
    }

	/*----- PROTECTED REGION END -----*/	//	Vg::get_device_property_after

}

//--------------------------------------------------------
/**
 *	Method      : Vg::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void Vg::always_executed_hook()
{
	INFO_STREAM << "Vg::always_executed_hook()  " << device_name << endl;
	/*----- PROTECTED REGION ID(Vg::always_executed_hook) ENABLED START -----*/

	if(update_allowed())
	{
		update_state();
	}

	/*----- PROTECTED REGION END -----*/	//	Vg::always_executed_hook
}



//--------------------------------------------------------
/**
 *	Method      : Vg::read_attr_hardware()
 *	Description : Hardware acquisition for attributes.
 */
//--------------------------------------------------------
void Vg::read_attr_hardware(vector<long> &attr_list)
{
	DEBUG_STREAM << "Vg::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Vg::read_attr_hardware) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Vg::read_attr_hardware

}


//--------------------------------------------------------
/**
 *	Read Pressure attribute
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Vg::read_Pressure(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Vg::read_Pressure(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Vg::read_Pressure) ENABLED START -----*/

	try
	{
		stringstream attr_name;
		attr_name << "Pressure_" << channel;

		tpg_proxy->read_attribute(attr_name.str().c_str()) >> *attr_Pressure_read;

		attr.set_value(attr_Pressure_read);
	}
	catch (Tango::DevFailed &ex)
	{
		exception_handler(ex, Tango::FAULT, "Vg::read_Pressure");
	}

	/*----- PROTECTED REGION END -----*/	//	Vg::read_Pressure
}
//--------------------------------------------------------
/**
 *	Read DeviceState attribute
 *	Description: 
 *
 *	Data type:	Tango::DevUChar
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Vg::read_DeviceState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Vg::read_DeviceState(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Vg::read_DeviceState) ENABLED START -----*/

	//	Set the attribute value
	attr.set_value(attr_DeviceState_read);

	/*----- PROTECTED REGION END -----*/	//	Vg::read_DeviceState
}

//--------------------------------------------------------
/**
 *	Write DeviceState attribute values to hardware.
 *
 *	Data type:	Tango::DevUChar
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Vg::write_DeviceState(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Vg::write_DeviceState(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevUChar	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Vg::write_DeviceState) ENABLED START -----*/

	if (w_val >= DEVICESTATE_T_SIZE) {
    Tango::Except::throw_exception("", "Value out of range", \
                                   "Vg::write_DeviceState()");
  }
  *attr_DeviceState_read = w_val;

	/*----- PROTECTED REGION END -----*/	//	Vg::write_DeviceState
}


//--------------------------------------------------------
/**
 *	Method      : Vg::VgClass::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *	              for specified device.
 */
//--------------------------------------------------------
void Vg::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Vg::Class::add_dynamic_attributes) ENABLED START -----*/

	//	Add your own code to create and add dynamic attributes if any

	/*----- PROTECTED REGION END -----*/	//	Vg::Class::add_dynamic_attributes

}



//========================================================
//	Command execution methods
//========================================================

//--------------------------------------------------------
/**
 *	Execute the On command:
 *	Description: 
 *
 *	@param argin 
 *	@returns 
 */
//--------------------------------------------------------
void Vg::on()
{
	DEBUG_STREAM << "Vg::On()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Vg::on) ENABLED START -----*/

	try
	{
		Tango::DeviceData dev_data;
		dev_data << channel;

		tpg_proxy->command_inout("SensorOn", dev_data);
	}
	catch (Tango::DevFailed &ex)
	{
			exception_handler(ex, Tango::FAULT, "Vg::on");
	}

	/*----- PROTECTED REGION END -----*/	//	Vg::on

}

//--------------------------------------------------------
/**
 *	Execute the Off command:
 *	Description: 
 *
 *	@param argin 
 *	@returns 
 */
//--------------------------------------------------------
void Vg::off()
{
	DEBUG_STREAM << "Vg::Off()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Vg::off) ENABLED START -----*/

	try
	{
		Tango::DeviceData dev_data;
		dev_data << channel;

		tpg_proxy->command_inout("SensorOff", dev_data);
	}
	catch (Tango::DevFailed &ex)
	{
		exception_handler(ex, Tango::FAULT, "Vg::off");
	}

	/*----- PROTECTED REGION END -----*/	//	Vg::off

}


	/*----- PROTECTED REGION ID(Vg::namespace_ending) ENABLED START -----*/

//========================================================
//	Private methods
//========================================================

//+------------------------------------------------------------------
/**
 *      method: Vg::is_update_state_allowed
 */
//+------------------------------------------------------------------
bool Vg::update_allowed()
{
	DEBUG_STREAM << "Vg::update_allowed()  - " << device_name << endl;

	bool is_allowed = false;

	if(init_completed)
	{
		if(get_state() == Tango::FAULT)
		{
			time_t now;
			time(&now);

			double elapsed_t = difftime(now, last_exception_t);

			WARN_STREAM  << "Back off: " << elapsed_t << "/" << current_back_off << " : " << maxBackOff << endl;

			if(elapsed_t >= current_back_off)
			{
				is_allowed = true;
				current_back_off = current_back_off * 2;

				if(current_back_off > maxBackOff)
				{
					current_back_off = maxBackOff;
				}
			}
		}
		else
		{
			current_back_off = 1;
			is_allowed = true;
		}
	}

	return is_allowed;
}

//+------------------------------------------------------------------
/**
 *      method: Vg::update_channel_state
 */
//+------------------------------------------------------------------
void Vg::update_state()
{
	DEBUG_STREAM << "Vg::update_state()  - " << device_name << endl;

	try
	{
		Tango::DevState old_state = get_state();

		stringstream attr_name;
		attr_name << "State_" << channel;

		Tango::DeviceAttribute dev_attr = tpg_proxy->read_attribute(attr_name.str().c_str());

		Tango::DevState new_state;
		dev_attr >> new_state;


		if(old_state == Tango::FAULT &&
				new_state != Tango::FAULT)
			register_name();

		set_state(new_state);


		attr_name.str("");
		attr_name << "Status_" << channel;

		dev_attr = tpg_proxy->read_attribute(attr_name.str().c_str());

		string new_status;
		dev_attr >> new_status;

		set_status(new_status);
	}
	catch (Tango::DevFailed &ex)
	{
		exception_handler(ex, Tango::FAULT, "Vg::update_state");
	}
}

//+------------------------------------------------------------------
/**
 *      method: Vg::register_name
 */
//+------------------------------------------------------------------
void Vg::register_name() throw(Tango::DevFailed)
{
	INFO_STREAM << "Vg::register_name(" << device_name << ","
			<< channel << ")  - " << device_name << endl;

	Tango::DevVarLongStringArray* array = new Tango::DevVarLongStringArray();

	array->lvalue.length(1);
	array->lvalue[0] = channel;

	array->svalue.length(1);
	array->svalue[0] = CORBA::string_dup(device_name.c_str());


	Tango::DeviceData dev_data;
	dev_data << array;

	tpg_proxy->command_inout("RegisterName", dev_data);
}

//+------------------------------------------------------------------
/**
 *      method: Vg::unregister_name
 */
//+------------------------------------------------------------------
void Vg::unregister_name() throw(Tango::DevFailed)
{
	INFO_STREAM << "Vg::unregister_name(" << device_name << ","
			<< channel << ")  - " << device_name << endl;

	Tango::DeviceData dev_data;
	dev_data << channel;

	tpg_proxy->command_inout("UnregisterName", dev_data);
}

//+------------------------------------------------------------------
/**
 *      method: Vg::exception_handler
 */
//+------------------------------------------------------------------
void Vg::exception_handler(Tango::DevFailed &ex, Tango::DevState new_state, const std::string base_msg)
{
	time(&last_exception_t);

    std::stringstream msg;

    msg << base_msg << " : ";
    for (unsigned int i=0; i<ex.errors.length(); i++)
    {
            msg << ex.errors[i].reason.in() << endl;
            msg << ex.errors[i].desc.in() << endl;
            msg << ex.errors[i].origin.in() << endl;
    }
    msg << ends;

    ERROR_STREAM << msg.str() << endl;

    set_state(new_state);
    set_status(msg.str());
}
// //--------------------------------------------------------
// /**
//  *	Read DeviceStatus attribute
//  *	Description: 
//  *
//  *	Data type:	Tango::DevString
//  *	Attr type:	Scalar 
//  */
// //--------------------------------------------------------
// void Vg::read_DeviceStatus(Tango::Attribute &attr)
// {
// 	DEBUG_STREAM << "Vg::read_DeviceStatus(Tango::Attribute &attr) entering... " << endl;
// 	//	Set the attribute value
// 	attr.set_value(attr_DeviceStatus_read);
// }


	/*----- PROTECTED REGION END -----*/	//	Vg::namespace_ending
} //	namespace
