/*----- PROTECTED REGION ID(VgClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        VgClass.h
//
// description : Include for the VgClass root class.
//               This class is the singleton class for.
//               the Vg device class..
//               It contains all properties and methods which the .
//               Vg requires only once e.g. the commands.
//
// project :     Vg.
//
// $Author: lorenzo $
//
// $Revision: 1.6 $
// $Date: 2013-06-17 10:30:33 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/vg/src/VgClass.h,v $
// $Log: VgClass.h,v $
// Revision 1.6  2013-06-17 10:30:33  lorenzo
// Added DeviceState attribute
//
// Revision 1.5  2013-06-05 15:41:02  lorenzo
// Tango 8.0.5
//
// Revision 1.4  2012-07-18 09:59:24  mdm
// New version, before test
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef VGCLASS_H
#define VGCLASS_H

#include <tango.h>
#include <Vg.h>

/*----- PROTECTED REGION END -----*/

namespace Vg_ns
{
	/*----- PROTECTED REGION ID(Vg::classes for dynamic creation) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Vg::classes for dynamic creation



//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Pressure class definition
class PressureAttrib: public Tango::Attr
{
public:
	PressureAttrib():Attr("Pressure",
	                   Tango::DEV_DOUBLE, Tango::READ) {};
	~PressureAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Vg *>(dev))->read_Pressure(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Vg *>(dev))->is_Pressure_allowed(ty);}
};

//	Attribute DeviceState class definition
class DeviceStateAttrib: public Tango::Attr
{
public:
	DeviceStateAttrib():Attr("DeviceState",
	                   Tango::DEV_UCHAR, Tango::READ_WRITE) {};
	~DeviceStateAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Vg *>(dev))->read_DeviceState(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Vg *>(dev))->write_DeviceState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Vg *>(dev))->is_DeviceState_allowed(ty);}
};





//=========================================
//	Define classes for commands
//=========================================
//	Command On class definition
class OnClass : public Tango::Command
{
public:
	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OnClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Vg *>(dev))->is_On_allowed(any);}
};

//	Command Off class definition
class OffClass : public Tango::Command
{
public:
	OffClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OffClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OffClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Vg *>(dev))->is_Off_allowed(any);}
};





/**
 *	The TemplateDevServClass singleton definition
 */

class
#ifdef _TG_WINDOWS_
	__declspec(dllexport)
#endif
	VgClass : public Tango::DeviceClass
{
	/*----- PROTECTED REGION ID(Vg::Additionnal DServer data members) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Vg::Additionnal DServer data members



public:
//	write class properties data members
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static VgClass *init(const char *);
	static VgClass *instance();
	~VgClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	VgClass(string &);
	static VgClass *_instance;
	void command_factory();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();
	void get_class_property();
	string get_cvstag();
	string get_cvsroot();

private:
	void device_factory(const Tango::DevVarStringArray *);
	void create_static_attribute_list(vector<Tango::Attr *> &);
	void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
	vector<string>	defaultAttList;


};

}	//	namespace

#endif	//	VGCLASS_H

