/*----- PROTECTED REGION ID(VgStateMachine.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: VgStateMachine.cpp,v 1.6 2013-06-17 10:30:33 lorenzo Exp $";
//=============================================================================
//
// file :        VgStateMachine.cpp
//
// description : C++ source for the name and its alowed
//               methods for commands and attributes
//
// project :     Vg.
//
// $Author: lorenzo $
//
// $Revision: 1.6 $
// $Date: 2013-06-17 10:30:33 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/vg/src/VgStateMachine.cpp,v $
// $Log: VgStateMachine.cpp,v $
// Revision 1.6  2013-06-17 10:30:33  lorenzo
// Added DeviceState attribute
//
// Revision 1.5  2013-06-05 15:41:02  lorenzo
// Tango 8.0.5
//
// Revision 1.4  2012-07-18 09:59:24  mdm
// New version, before test
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================



#include <Vg.h>
#include <VgClass.h>

/*----- PROTECTED REGION END -----*/


/*
 * Vg states description:
 *
 * ON :	 
 * OFF :	 
 * ALARM :	 
 * DISABLE :	 
 * FAULT :	 
 */

namespace Vg_ns
{

//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : Vg::is_PressureState_allowed()
 *	Description : Execution allowed for Pressure attribute.
 */
//--------------------------------------------------------

bool Vg::is_Pressure_allowed(Tango::AttReqType type)
{
	if (	//	Compare device state with not allowed states for READ 
		get_state() == Tango::OFF	|| 
		get_state() == Tango::DISABLE	|| 
		get_state() == Tango::FAULT)
	{
	
	/*----- PROTECTED REGION ID(Vg::read_PressureStateAllowed_READ) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Vg::read_PressureStateAllowed_READ

		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Vg::is_DeviceStateState_allowed()
 *	Description : Execution allowed for DeviceState attribute.
 */
//--------------------------------------------------------

bool Vg::is_DeviceState_allowed(Tango::AttReqType type)
{
	//	Check if access type.
	if ( type!=Tango::READ_REQ )
	{
			//	Not any excluded states for DeviceState attribute in WRITE access.
		
	/*----- PROTECTED REGION ID(Vg::DeviceStateStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Vg::DeviceStateStateAllowed_WRITE

		return true;
	}
	else
		//	Not any excluded states for DeviceState attribute in READ access.
	
	/*----- PROTECTED REGION ID(Vg::read_DeviceStateStateAllowed_READ) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Vg::read_DeviceStateStateAllowed_READ

	return true;
}


	/*----- PROTECTED REGION ID(Vg::are_dynamic_attributes_allowed) ENABLED START -----*/

	//	Add your code to check if dynamic attributes are alowed

	/*----- PROTECTED REGION END -----*/	//	Vg::are_dynamic_attributes_allowed


//=================================================
//		Commands Allowed Methods
//=================================================


//--------------------------------------------------------
/**
 *	Method      : Vg::is_OnState_allowed()
 *	Description : Execution allowed for On command.
 */
//--------------------------------------------------------

bool Vg::is_On_allowed(const CORBA::Any &any)
{
	if (	//	Compare device state with not allowed states for command 
		get_state() == Tango::ON	|| 
		get_state() == Tango::DISABLE	|| 
		get_state() == Tango::FAULT)
	{

	/*----- PROTECTED REGION ID(Vg::OnStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Vg::OnStateAllowed

		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Vg::is_OffState_allowed()
 *	Description : Execution allowed for Off command.
 */
//--------------------------------------------------------

bool Vg::is_Off_allowed(const CORBA::Any &any)
{
	if (	//	Compare device state with not allowed states for command 
		get_state() == Tango::OFF	|| 
		get_state() == Tango::DISABLE	|| 
		get_state() == Tango::FAULT)
	{

	/*----- PROTECTED REGION ID(Vg::OffStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Vg::OffStateAllowed

		return false;
	}
	return true;
}


	/*----- PROTECTED REGION ID(Vg::are_dynamic_commands_allowed) ENABLED START -----*/

	//	Add your code to check if dynamic commands are alowed

	/*----- PROTECTED REGION END -----*/	//	Vg::are_dynamic_commands_allowed

}	// namespace Vg_ns
